std::_Fwd_list_base< _Tp, _Alloc > Struct Template Reference

`#include <forward_list.h>`

Inheritance diagram for std::_Fwd_list_base< _Tp, _Alloc >:
[legend]

## Public Types

typedef _Fwd_list_node< _Tp > | _Node
typedef _Fwd_list_const_iterator< _Tp > | const_iterator
typedef _Fwd_list_iterator< _Tp > | iterator

## Public Member Functions

| _Fwd_list_base (_Fwd_list_base &&)=default
| _Fwd_list_base (_Fwd_list_base &&__lst, _Node_alloc_type &&__a)
| _Fwd_list_base (_Fwd_list_base &&__lst, _Node_alloc_type &&__a, std::true_type)
| _Fwd_list_base (_Node_alloc_type &&__a)
const _Node_alloc_type & | _M_get_Node_allocator () const noexcept
_Node_alloc_type & | _M_get_Node_allocator () noexcept

## Protected Types

typedef __gnu_cxx::__alloc_traits< _Node_alloc_type > | _Node_alloc_traits
typedef __alloc_rebind< _Alloc, _Fwd_list_node< _Tp > > | _Node_alloc_type

## Protected Member Functions

template<typename... _Args>
_Node * | _M_create_node (_Args &&... __args)
_Fwd_list_node_base * | _M_erase_after (_Fwd_list_node_base *__pos)
_Fwd_list_node_base * | _M_erase_after (_Fwd_list_node_base *__pos, _Fwd_list_node_base *__last)
_Node * | _M_get_node ()
template<typename... _Args>
_Fwd_list_node_base * | _M_insert_after (const_iterator __pos, _Args &&... __args)
void | _M_put_node (_Node *__p)

## Protected Attributes

_Fwd_list_impl | _M_impl

## Detailed Description

template<typename _Tp, typename _Alloc>
struct std::_Fwd_list_base< _Tp, _Alloc >

Base class for forward_list.

Definition at line 287 of file forward_list.h.

## Member Typedef Documentation

## _Node

template<typename _Tp , typename _Alloc >

typedef _Fwd_list_node<_Tp> std::_Fwd_list_base< _Tp, _Alloc >::_Node

Definition at line 319 of file forward_list.h.

## _Node_alloc_traits

template<typename _Tp , typename _Alloc >

typedef __gnu_cxx::__alloc_traits<_Node_alloc_type> std::_Fwd_list_base< _Tp, _Alloc >::_Node_alloc_traits

protected

Definition at line 291 of file forward_list.h.

## _Node_alloc_type

template<typename _Tp , typename _Alloc >

typedef __alloc_rebind<_Alloc, _Fwd_list_node<_Tp> > std::_Fwd_list_base< _Tp, _Alloc >::_Node_alloc_type

protected

Definition at line 290 of file forward_list.h.

## const_iterator

template<typename _Tp , typename _Alloc >

typedef _Fwd_list_const_iterator<_Tp> std::_Fwd_list_base< _Tp, _Alloc >::const_iterator

Definition at line 318 of file forward_list.h.

## iterator

template<typename _Tp , typename _Alloc >

typedef _Fwd_list_iterator<_Tp> std::_Fwd_list_base< _Tp, _Alloc >::iterator

Definition at line 317 of file forward_list.h.

## Constructor & Destructor Documentation

## _Fwd_list_base() [1/3]

template<typename _Tp , typename _Alloc >

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Node_alloc_type && | __a | ) |

inline

Definition at line 331 of file forward_list.h.

## _Fwd_list_base() [2/3]

template<typename _Tp , typename _Alloc >

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Fwd_list_base< _Tp, _Alloc > && | __lst,
|  | _Node_alloc_type && | __a,
|  | std::true_type |
| ) |  |

inline

Definition at line 335 of file forward_list.h.

## _Fwd_list_base() [3/3]

template<typename _Tp , typename _Alloc >

std::_Fwd_list_base< _Tp, _Alloc >::_Fwd_list_base | ( | _Fwd_list_base< _Tp, _Alloc > && | __lst,
|  | _Node_alloc_type && | __a
| ) |  |

Definition at line 39 of file forward_list.tcc.

## ~_Fwd_list_base()

template<typename _Tp , typename _Alloc >

std::_Fwd_list_base< _Tp, _Alloc >::~_Fwd_list_base | ( |  | ) |

inline

Definition at line 345 of file forward_list.h.

## Member Function Documentation

## _M_create_node()

template<typename _Tp , typename _Alloc >
template<typename... _Args>

_Node * std::_Fwd_list_base< _Tp, _Alloc >::_M_create_node | ( | _Args &&... | __args | ) |

inline protected

Definition at line 358 of file forward_list.h.

## _M_erase_after() [1/2]

template<typename _Tp , typename _Alloc >

_Fwd_list_node_base * std::_Fwd_list_base< _Tp, _Alloc >::_M_erase_after | ( | _Fwd_list_node_base * | __pos | ) |

protected

Definition at line 63 of file forward_list.tcc.

## _M_erase_after() [2/2]

template<typename _Tp , typename _Alloc >

_Fwd_list_node_base * std::_Fwd_list_base< _Tp, _Alloc >::_M_erase_after | ( | _Fwd_list_node_base * | __pos,
|  | _Fwd_list_node_base * | __last
| ) |  |

protected

Definition at line 77 of file forward_list.tcc.

## _M_get_node()

template<typename _Tp , typename _Alloc >

_Node * std::_Fwd_list_base< _Tp, _Alloc >::_M_get_node | ( |  | ) |

inline protected

Definition at line 350 of file forward_list.h.

## _M_get_Node_allocator() [1/2]

template<typename _Tp , typename _Alloc >

const _Node_alloc_type & std::_Fwd_list_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) | const

inline noexcept

Definition at line 326 of file forward_list.h.

## _M_get_Node_allocator() [2/2]

template<typename _Tp , typename _Alloc >

_Node_alloc_type & std::_Fwd_list_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) |

inline noexcept

Definition at line 322 of file forward_list.h.

## _M_insert_after()

template<typename _Tp , typename _Alloc >
template<typename... _Args>

_Fwd_list_node_base * std::_Fwd_list_base< _Tp, _Alloc >::_M_insert_after | ( | const_iterator | __pos,
|  | _Args &&... | __args
| ) |  |

protected

Definition at line 50 of file forward_list.tcc.

## _M_put_node()

template<typename _Tp , typename _Alloc >

void std::_Fwd_list_base< _Tp, _Alloc >::_M_put_node | ( | _Node * | __p | ) |

inline protected

Definition at line 381 of file forward_list.h.

## Member Data Documentation

## _M_impl

template<typename _Tp , typename _Alloc >

_Fwd_list_impl std::_Fwd_list_base< _Tp, _Alloc >::_M_impl

protected

Definition at line 314 of file forward_list.h.

The documentation for this struct was generated from the following files:

- forward_list.h
- forward_list.tcc